=== data/example_projects/CMakeLists.txt ===
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} DESTINATION ${KDE_INSTALL_DATADIR}/${PROJECT_NAME} PATTERN "CMakeLists.txt" EXCLUDE)
