=== tests/backend/CMakeLists.txt ===
option(ENABLE_TEST_BACKEND "Enable Backend Tests" ON)

if (ENABLE_TEST_BACKEND)

    add_subdirectory(Axis)
    add_subdirectory(BarPlot)
    add_subdirectory(Column)
    add_subdirectory(core)
    add_subdirectory(Datapicker)
    add_subdirectory(gsl)
    add_subdirectory(InfoElement)
    add_subdirectory(Parser)
    add_subdirectory(Range)
    add_subdirectory(Retransform)
    add_subdirectory(TextLabel)
    add_subdirectory(Worksheet)
    add_subdirectory(XYCurve)

endif()
