=== debian/changelog ===
labplot (2.11.1-2) unstable; urgency=medium

  * Disable the Cantor integration for now, as Cantor will be switched soon to
    Qt 6:
    - drop the libcantor-dev build dependency

 -- Pino Toscano <pino@debian.org>  Tue, 18 Feb 2025 22:52:03 +0100

labplot (2.11.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - add liborcus-dev, and libixion-dev
    - add libboost-dev as missing dependency of libixion-dev

 -- Pino Toscano <pino@debian.org>  Wed, 17 Jul 2024 21:05:08 +0200

labplot (2.11.0-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump Qt packages to 5.12.0
    - bump KF packages to 5.32.0
    - add qtbase5-private-dev, libkf5purpose-dev, and libeigen3-dev
    - add libqt5sql5-sqlite for tests
  * Update the patches:
    - upstream_matio-Fix-compilation-for-latest-version-1.5.27.patch: drop,
      backported from upstream
  * Do not ship development bits (e.g. headers) for now.
  * Update install files.
  * Update lintian overrides.
  * CI: make the build non-verbose, so the build log fits within the salsa
    limits.

 -- Pino Toscano <pino@debian.org>  Sat, 13 Jul 2024 21:07:39 +0200

labplot (2.10.1-3) unstable; urgency=medium

  * Backport upstream commit d6142308ffa492d9f7cea00fad3b4cd1babfd00c to fix the
    build with newer versions of matio; patch
    upstream_matio-Fix-compilation-for-latest-version-1.5.27.patch.
    (Closes: #1072280)
  * Bump Standards-Version to 4.7.0, no changes required.
  * Switch the transitional pkg-config build dependency to pkgconf.
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Sun, 02 Jun 2024 21:04:24 +0200
